;*****SupercarI 1.0 by Th.Fernique and A.Jalabert******
       
	include "flib.h"
	include "hufflib.h"
	include "tios.h"
	xdef    _main
	xdef    _comment
;***************************************;
 include  SUPERCAR.H
writestr MACRO
 move.w  \3,-(a7)
 pea     \4(PC)
 move.w  \2,-(a7)
 move.w  \1,-(a7)
 jsr     tios::DrawStrXY
 lea    10(a7),a7
 ENDM
;***************************************;
  ;  include   "sup1.sdb"
_main:
 
 move.l  #9680,-(a7)                    ;y a ti 9680 octets ? (352*220 pixels)
 jsr     tios::HeapAlloc
 lea     4(a7),a7
 tst.w   d0
 beq     MEM_ERROR                      ;non=>pas de supercar !!!
 move.w  d0,hnum
 tios::DEREF d0,a0
 move.l  a0,hptr
 move.w  #$000F,d0                      ;Decompression of the image and the
 tios::DEREF d0,a1                      ;track will be in the prgmIO handle!!
 add.l   #4,a1
 move.l  a1,IOptr      
 move.w  #$0013,d0                     
 tios::DEREF d0,a1                    
 add.l   #4,a1
 move.l  a1,Grptr      

 trap    #1
 move.l  $64,oldint#1
 bclr.b  #2,$600001
 move.l  #newint#1,$64
 bset.b  #2,$600001
 trap    #1
 
 
menu:
 bsr     clrscr
 move.w  #0,-(a7)       
 jsr     tios::FontSetSys      ;fonte texte #0
 lea     2(a7),a7
 writestr #60,#117,#4,credit
 writestr #60,#123,#4,mail
 move.w  #2,-(a7)       
 jsr     tios::FontSetSys      ;fonte texte #2
 lea     2(a7),a7
 writestr #56,#10,#4,title
 writestr #60,#50,#4,menumsg1
; writestr #60,#60,#4,menumsg2
 writestr #60,#60,#4,exittt
loopp: 
 bsr     getkeystat
 btst.b  #4,keystat+6                   ;F1 ?  = 1 joueur
 beq     choicee
 btst.b  #6,keystat+8                    ;ESC
 beq     NORMAL_EXIT
 bra     loopp

choicee:
 bsr     menuselect
 cmp.w   #3,d2
 beq     menu
 bra     Main_

menuselect:                     
 movem.l d0-d1/a0,-(a7)
 lea     menuc(PC),a6
 jsr     flib::show_dialog
 move.w  #1,d2
PutDiff:
 lea     menuselect1(PC),a0
 move.w  #46,d1
 move.w  #2,d0
RepPutDiff:
 movem.l d0-d2/a0,-(a7)
 cmp     d0,d2
 bne     NoSelect
 move.w  #0,-(a7)
 bra     SuiteDiff  
NoSelect:
 move.w  #4,-(a7)
SuiteDiff:
 move.l  a0,-(a7)
 move.w  d1,-(a7)
 move.w  #88,-(a7)
 jsr     tios::DrawStrXY
 lea     10(a7),a7
 movem.l (a7)+,d0-d2/a0
 lea     10(a0),a0
 add.w   #12,d1
 dbra    d0,RepPutDiff
 bsr     getkeystat
 btst.b  #5,keystat
; jsr     flib::idle_loop           doesn't work!!!!!!!i don't know why!!amazing...
; cmp     #338,d0
 bne     D_NoUp
 cmp     #2,d2
 beq     D_NoUp
 add.w   #1,d2
D_NoUp:
 btst.b  #7,keystat
; cmp     #344,d0
 bne     D_NoDown
 cmp     #0,d2
 beq     D_NoDown
 sub.w   #1,d2
D_NoDown:
 btst.b  #6,keystat+6             ;ENTER2  PAD
; cmp     #13,d0
 beq     DiffEnd
 btst.b  #6,keystat+8
; cmp     #264,d0
 bne     PutDiff
 move.w  #3,d2
 beq     fin_ 
DiffEnd:
 move.w  d2,choice
fin_: 
 movem.l (a7)+,d0-d1/a0
 rts

Main_: 
 
 bsr     loadlevel                      ;Charge le circuit dans le handle (le dcompresse)

;**dessine le zolie dessin**;

 bsr     clrscr
 lea     circuit(PC),a0                 ; Make A0 point to huffman compressed data
 move.l  IOptr,a1
 move.w  #3,d3                          ; File 4 
 jsr     hufflib::extract               ; Extract A0 -> A1
 move.l #127,d2           
 move.l #LCD_MEM,a3                     ;LCD_MEM
 adda.w  #18,a3
 adda.w #32,a1
boucle:
 move.l (a1),(a3)
 move.l 4(a1),4(a3)
 move.l 8(a1),8(a3)
 add.w  #30,a3 
 add.w  #12,a1      ;12
 dbra d2,boucle


;*****initialisation des variables******;
 
 lea     circuit(PC),a0  
 move.l  IOptr,a1
 move.w  #4,d3                  ; File 5 : cars!!!!!!!!!!!! (At least)
 jsr     hufflib::extract       ; Extract A0 -> A1
 move.l  #63,d2           
 move.l  Grptr,a3          
 adda.w  #32,a1
bouclee:
 move.l (a1),(a3)
 move.l 4(a1),4(a3)
 move.l 8(a1),8(a3)
 move.l 12(a1),12(a3)
 add.w  #30,a3 
 add.w  #16,a1      
 dbra d2,bouclee

 move.l  Grptr,a1 
 adda.l  #$780,a1                       ;8AC
 lea     circuit(PC),a0  
 move.w  #5,d3                  ; File 6 :Masks
 jsr     hufflib::extract       ; Extract A0 -> A1
 move.l  #63,d2           
 move.l  IOptr,a3          
 adda.w  #32,a1
boucleet:
 move.l (a1),(a3)
 move.l 4(a1),4(a3)
 move.l 8(a1),8(a3)
 move.l 12(a1),12(a3)
 add.w  #30,a3 
 add.w  #16,a1      
 dbra d2,boucleet
 
 lea     costab(PC),a0
 move.l  a0,cos_ptr      
 move.w  #0,xecran
 move.w  #0,yecran
 move.w  #1,vitesse 
 move.w  #14999,vitt
 move.w  #6,braquage
 move.w  #0,timer
 move.w  #0,timer2
 move.w  #0,timeflag
 move.b  #0,lapflag
 move.b  #0,borneflag
 move.w  #9999,best1
 move.w  #9999,lasttime
 affiche_last_time                 
 affiche_best1
 affiche_best2
 move.w  #$A,delayvar
MAIN:
;*****************ROTATION**************;
 move.w  delayvar,d3                    ;ralentit pour ti92II ou calc boostees
Oh_calm:                                ;Thx  Thomas... :)
 cmp.w   timer2,d3
 bgt     Oh_calm
 clr.w   timer2

 clr.l   d0
 clr.b   news
okgo:
 btst.b  #0,keystat+9             ;moins
 beq     DecContrast
 btst.b  #4,keystat+8           ;plus
 beq     IncContrast
retour: 
 move.w  braquage,d0              ;;;;;;;;
 btst.b  #4,keystat                     ;fleche gauche ?
 bne     noleft
 sub.w   d0,angle                       ;angle-d0
 move.b  #%00000001,news
 tst.w   angle
 bge     noleft
 add.w   #360,angle                     ;modulo 2 pi
noleft:
 btst.b  #6,keystat                     ;fleche droite ?
 bne     noright
 add.w   d0,angle                       ;angle+d0
 move.b  #%00000010,news
 cmp     #360,angle
 blt     noright
 sub.w   #360,angle                     ;modulo 2 pi
  

noright:           
;Acclration
 bsr     getkeystat
 btst.b  #4,keystat+6                       ;F1
 bne     frein
 or.b    #%00000100,news             
 cmp     #2000,vitt
 blt     gearup
 sub.w   #2000,vitt
 tst.w   vitt
 beq     gearup
 bra     delai 

frein:
 btst.b  #4,keystat+4                      ;F2
 bne     testf
 or.b    #%00001000,news
 cmp     #15000,vitt
 bge     geardown
 add.w   #4000,vitt
 bra     delai

testf:
 cmp     #15000,vitt
 bne     pasacc
 bra     geardown
 

delai: 
 move.w  vitt,d5                
delai_:
 nop
 dbra    d5,delai_
 bra     go

pasacc:
 cmp     #15000,vitt
 bge     geardown
 add.w   #1000,vitt
 or.b    #%00010000,news 
 bra     delai

gearup:
 cmp     #3,vitesse
 bge     go
 addq    #1,vitesse
 subq    #1,braquage
 move.w  #12000,vitt
 bra delai
 
geardown:
 cmp     #1,vitesse
 ;beq     testang
 beq     PASBOUGE
 subq    #1,vitesse
 addq    #1,braquage
 move.w  #8000,vitt 
 or.b    #%00010000,news 
 bra     delai


		 
;********change les coordonnes*********;

go: 
 move.w  vitesse,d3
 move.w  d3,vitess 
 add.w   #10,vitess 
 move.w  x,d3
 move.w  d3,x_
 move.w  y,d3 
 move.w  d3,y_
 move.w  angle,d0
 cmp.w   #0,d0
 beq     youps
 cmp.w   #90,d0
 beq     youps
 cmp.w   #180,d0
 beq     youps
 cmp.w   #270,d0
 beq     youps
 bra     pas_youps
youps:
 addq    #1,d0
pas_youps:
 clr.l   d1
 move.l  cos_ptr,a0
;a0_90
 cmp     #90,d0
 bgt     a90_180
 move.w  #0,ligne
 move.b  0(a0,d0),d1
 move.w  d1,d3
 mulu    vitesse,d1
 mulu    vitess,d3
 add.w   d1,x                           ;x=x+cos(angle)
 add.w   d3,x_
 clr.l   d1
 move.w  #90,d2
 sub.w   d0,d2
 move.b  0(a0,d2),d1
 move.w  d1,d3
 mulu    vitesse,d1
 mulu    vitess,d3
 add.w   d1,y                           ;y=y+sin(angle)
 add.w   d3,y_
 bra     afin
a90_180:
 cmp     #180,d0
 bgt     a180_270
 move.w  #180,d2
 sub.w   d0,d2
 move.w  #16,ligne 
 move.b  0(a0,d2),d1
 move.w  d1,d3
 mulu    vitesse,d1
 mulu    vitess,d3
 sub.w   d1,x
 sub.w   d3,x_
 clr.l   d1
 move.w  d0,d2
 sub.w   #90,d2
 move.b  0(a0,d2),d1
 move.w  d1,d3
 mulu    vitesse,d1
 mulu    vitess,d3
 add.w   d1,y
 add.w   d3,y_
 bra     afin
a180_270:
 cmp     #270,d0
 bgt     a270_360
 move.w  d0,d2
 sub.w   #180,d2
 move.w  #32,ligne
 move.b  0(a0,d2),d1
 move.w  d1,d3
 mulu    vitesse,d1
 mulu    vitess,d3
 sub.w   d1,x
 sub.w   d3,x_
 clr.l   d1
 move.w  #270,d2
 sub.w   d0,d2
 move.b  0(a0,d2),d1
 move.w  d1,d3
 mulu    vitesse,d1
 mulu    vitess,d3
 sub.w   d1,y
 sub.w   d3,y_
 bra     afin
a270_360:
 move.w  #360,d2
 sub.w   d0,d2
 move.w  #48,ligne
 move.b  0(a0,d2),d1
 move.w  d1,d3
 mulu    vitesse,d1
 mulu    vitess,d3
 add.w   d1,x
 add.w   d3,x_
 clr.l   d1
 move.w  d0,d2
 sub.w   #270,d2
 move.b  0(a0,d2),d1
 move.w  d1,d3
 mulu    vitesse,d1
 mulu    vitess,d3
 sub.w   d1,y
 sub.w   d3,y_
afin:
 bra     apres
PASBOUGE: 
; bra     apres
 cmpi.b  #1,news 
 beq     g_o
 cmpi.b  #2,news 
 beq     g_o
 cmpi.b  #10,news 
; beq     g_o
; cmpi.b  #9,news 
; beq     g_o
 bra     apres
g_o: 
 clr.b   news
 bra     go
apres:
 cmp     #0,x                           ;(x,y) sur l'cran ?
 bgt     c1                             ;si non, on y remdie.
 move.w  #0,x    
c1:       
 cmp     #344*64,x          ;343
 blt     c2
 move.w  #344*64,x
c2:
 cmp     #8*64,y  
 bgt     c3
 move.w  #8*64,y 
c3:
 cmp     #212*64,y            ;211
 blt     c4
 move.w  #212*64,y
c4:

;********passage d'une ligne************;
 move.w  x,d0
 lsr.w   #6,d0
 move.w  y,d1
 lsr.w   #6,d1
 move.w  lastx,d2
 lsr.w   #6,d2 
 move.w  lasty,d3
 lsr.w   #6,d3
 move.w  x,lastx                        ;remet  jour lastx et lasty
 move.w  y,lasty

 cmp     d0,d2
 bne     bouge_ok
 cmp     d1,d3
 bne     bouge_ok
 bra     paspasse
bouge_ok:
 lea     lapline(PC),a1
 move.w  curline,d4
 lsl.w   #3,d4
 add.w   d4,a1
 clr.l   d4

 lea     coord(PC),a0                   ;charge les 4 pts dans coord
 move.w  (a1)+,(a0)+                    ;a.x 1er pt de la ligne
 move.w  (a1)+,(a0)+                    ;a.y
 move.w  (a1)+,(a0)+                    ;b.x 2eme pt de la ligne
 move.w  (a1)+,(a0)+                    ;b.y
 move.w  d2,(a0)+                       ;c.x position prcdente de la voiture
 move.w  d3,(a0)+                       ;c.y
 move.w  d0,(a0)+                       ;d.x nouvelle position
 move.w  d1,(a0)+                       ;d.y
 bsr     checkpass
 tst.b   borneflag
 beq     paspasse
 add.w   #1,curline
 cmp     #3,curline                     ;passe contr"le ou ligne d'arrive ?
 bne     JustPassControl
 clr.w   curline
 move.b  #1,lapflag
JustPassControl:
 clr.b   borneflag
paspasse:
;***************************************;
 move.l  d4,-(a7)
 move.w  x_,d0
 lsr.w   #6,d0
 move.w  y_,d1
 lsr.w   #6,d1

 bsr     getpixel                       ;hors-piste ?
 tst.b   d4
 beq     pas_sur_l_herbe
 move.w  #10000,d4                      ;oui=>delay
dl:
 nop
 dbra    d4,dl
 move.w  #1,vitesse   
 move.w  #6,braquage   

pas_sur_l_herbe:
 move.l  (a7)+,d4
 

 move.w  x,d0    
 lsr.w   #6,d0     
 move.w  y,d1   
 lsr.w   #6,d1     
 movem.l d0-d4,-(a7)
 move.l  Grptr,a0
 move.w  ligne,d0
 mulu.w  #30,d0
 adda.l  d0,a0
 bsr     colonne 
 mulu.w  #2,d2
 adda.l  d2,a0
 movem.l (a7)+,d0-d4  
 
 lea     autoo(PC),a1
 move.w  #15,d2           
boucleee:
 move.w (a0),(a1)
 add.w  #2,a1 
 add.w  #30,a0      
 dbra   d2,boucleee
;oups:
 movem.l d0-d4,-(a7)  
 move.l  IOptr,a0
 move.w  ligne,d0
 mulu.w  #30,d0
 adda.l  d0,a0
 bsr     colonne 
 mulu.w  #2,d2
 adda.l  d2,a0
 movem.l (a7)+,d0-d4  
; lea     mask(PC),a1
 move.w  #15,d2           
boucleee2:
 move.w (a0),(a1)
 add.w  #2,a1 
 add.w  #30,a0      
 dbra   d2,boucleee2

 lea     autoo(PC),a0
 ;move.b  #0,test
 bsr     PutSprite

 move.w  x,d0
 lsr.w   #6,d0
 move.w  y,d1
 lsr.w   #6,d1

;********* affiche l'cran *************;

 movem.l d0-d1,-(a7)
 sub.w   #72,d0
 sub.w   #63,d1
;vrifie les coordonns
 cmp     #0,d0           
 bge     ok1
 move.w  #0,d0     
ok1:
 cmp     #352-144,d0
 ble     ok2
 move.w  #352-144,d0
ok2:
 cmp     #0,d1          
 bge     ok3
 move.w  #0,d1         
ok3:
 cmp     #220-128,d1
 ble     ok4
 move.w  #220-128,d1
ok4:
 move.w  d0,xecran
 move.w  d1,yecran
 bsr     puthandle                      ;affiche le tout  l'cran
 movem.l (a7)+,d0-d1
 ;move.w  #2,test
; bsr     putbg                          ;efface tout de suite la voiture dans le handle
 
 move.w  x,d0     
 lsr.w   #6,d0    
 move.w  y,d1        
 lsr.w   #6,d1      
; move.b  #0,test
 bsr     RemoveSprite

;********* affiche les temps ***********;
 ;
 ;affiche_braquage                                            
 ;affiche_angle                                                
 ;affiche_regime                                              
 ;affiche_news
 affiche_gear                                               
CURRENT_TIME:
 tst.b   timeflag      ;timeflag<>0 ?                        
 bne     NORMAL_EXIT   ;oui=>on quitte (timer a expir)          
 affiche_current_time
 tst.b   lapflag
 beq     le_tour_il_                    ;est_pas_encore_fini
 move.w  timer,d7
 move.w  d7,lasttime
 affiche_last_time
 cmp     best1,d7                       ;best1 battu ?
 bge     pasrecord
 cmp     #1500,d7                  
 blt     pasrecord                     
 move.w  d7,best1
 affiche_best1
 cmp     best2,d7                       ;best2 battu ?
 bge     pasrecord
 cmp     #1500,d7                   
 blt     pasrecord                      
 move.w  d7,best2                       ;oui=>on le stocke
; move.l  best2_addr,a0
 lea     BestTimes(PC),a0
 move.w  choice,d1
 mulu    #2,d1
 add.w   d1,a0
 move.w  d7,(a0)
 affiche_best2

pasrecord:
 clr.w   timer
 clr.b   lapflag
le_tour_il_:                             ;est_pas_encore_fini:
 tst.w    vitt 
 beq     souite
 movem.l d0-d4/a0,-(a7)
 bsr     clrr                                  ;erase speedometer    
 move.w  vitt,d0
 lsr.w   #7,d0                         ;vitt/128
 add.w   #56,d0
 clr.l   d1
 move.w  #197,xs
 move.w  #24,ys                       ;20*64

 move.l  cos_ptr,a0

;a0_90s
 cmp     #90,d0
 bgt     a90_180s
 move.b  0(a0,d0),d1
 lsr.w   #2,d1
 add.w   d1,xs                           ;x=x+cos(angle)
 clr.l   d1
 move.w  #90,d2
 sub.w   d0,d2
 move.b  0(a0,d2),d1
 lsr.w   #2,d1
 sub.w   d1,ys                           ;y=y+sin(angle)
 bra     afins
a90_180s:
 move.w  #180,d2
 sub.w   d0,d2
 move.b  0(a0,d2),d1
 lsr.w   #2,d1
 sub.w   d1,xs
 clr.l   d1
 move.w  d0,d2
 sub.w   #90,d2
 move.b  0(a0,d2),d1
 lsr.w   #2,d1
 sub.w   d1,ys

afins:
 move.w   xs,d2
 move.w   ys,d3
 move.l   #LCD_MEM,a0 
 move.w   #197,d0
 move.w   #24,d1
 bsr      Fline
 movem.l  (a7)+,d0-d4/a0


souite:
 btst.b  #6,keystat+8                   ;ESC ?
 bne     MAIN                           ;non => on continue
 bra     menu
NORMAL_EXIT:
 ;remet l'ancienne int1 en place
 move.w  #$0700,d0
 trap    #1
 bclr.b  #2,$600001
 move.l  oldint#1(pc),$64
 bset.b  #2,$600001
 trap    #1
;LEVEL_ERROR:
;debug:                                          ;libre mmoire
 move.w  hnum,-(a7)
 jsr     tios::HeapFree
 addq    #2,a7
 clr.w   $75B0                        ;;;;;;;;;;;;;;;;;;    
MEM_ERROR:
 rts

;****************FONCTIONS**************;
colonne:
 movem.l d0-d1,-(a7) 
 move.w  angle,d0
smufff: 
 mulu.w  #100,d0
 moveq   #1,d2
tst_angle:
 move.w  #1125,d1
 mulu.w  d2,d1
 cmp.l   d1,d0
 blt     okeyfin
 addq    #1,d2
 bra     tst_angle
okeyfin: 
 subq    #1,d2
okeyfinn:
 cmp.w   #8,d2
 blt     vraifin
 subq    #8,d2
 bra     okeyfinn
vraifin:
 movem.l (a7)+,d0-d1
 rts


puthandle:   ;(d0,d1)=(x,y)
 ;rts
 movem.l d0-d7/a0-a1,-(a7)
 move.l  #LCD_MEM,a0
 move.l  hptr,a1

 move.w  d1,d2                          ;multiplie y par 44 (44 octets dans une ligne du handle)
 lsl.w   #2,d1                          ;4y
 move.w  d1,d2
 lsl.w   #1,d2                          ;2*4y
 move.w  d2,d3
 lsl.w   #2,d3                          ;4*8y
 add.w   d3,d2                          ;32y+8y=40y
 add.w   d2,d1                          ;40y+4y=44y
 add.l   d1,a1                          ;et ajoute 44y  a1

 move.w  d0,d2                          ;deplacement x en word
 lsr.w   #3,d2                          ;div 8
 and.w   #$FFFE,d2                      ;supprime bit 1
 add.l   d2,a1
 move.w  d0,d2                          ;dplacement par rapport au plus proche word
 and.w   #%1111,d2                      ;garde bits 1-4 (0-15)
 cmp     #8,d2
 bgt     suite2
suite1:
 move.w  #$FFFF,d3                      ; #%1111111111111111
 lsl.w   d2,d3                          ; #%1111111111100000  <-
 lsr.w   d2,d3                          ; #%0000011111111111  ->
 move.w  d3,d4
 not.w   d4                             ; #%1111100000000000
 move.w  #127,d7                        ;lignes balayes-1
nextline1:
 move.w  #8,d6
nextword1:
 move.w  (a1)+,d0
 move.w  (a1),d1
 and.w   d3,d0
 and.w   d4,d1
 rol.w   d2,d0
 rol.w   d2,d1
 add.w   d1,d0
 move.w  d0,(a0)+
 dbra    d6,nextword1
 add.l   #26,a1
 add.l   #12,a0
 dbra    d7,nextline1
 bra     fin
suite2:
 move.w  #16,d3
 sub.w   d2,d3
 move.w  d3,d2
 move.w  #$FFFF,d4                      ; #%1111111111111111
 lsl.w   d2,d4                          ; #%1111111111100000  <-
 move.w  d4,d3
 not.w   d3                             ; #%0000000000011111
 move.w  #127,d7                        ;lignes balayes-1
nextline2:
 move.w  #8,d6
nextword2:
 move.w  (a1)+,d0
 move.w  (a1),d1
 and.w   d3,d0
 and.w   d4,d1
 ror.w   d2,d0
 ror.w   d2,d1
 add.w   d1,d0
 move.w  d0,(a0)+
 dbra    d6,nextword2
 add.l   #26,a1
 add.l   #12,a0
 dbra    d7,nextline2
fin:
 movem.l (a7)+,d0-d7/a0-a1
 rts



;***************************************;
convstr:
 movem.l d0-d2,-(a7)
 clr.b   (a0)
repconv:
 divu    #10,d0
 move.l  d0,d2
 swap    d2
 add.b   #48,d2
 move.b  d2,-(a0)
 subq    #1,d1
 and.l   #$FFFF,d0
 bne     repconv
 tst.w   d1
 beq     CS_Done
 subq    #1,d1
FillOut:
 move.b  #48,-(a0)
 dbra    d1,FillOut
CS_Done:
 movem.l (a7)+,d0-d2
 rts

;********************************************************
getkeystat:
 movem.l d0-d1/a0,-(a7)
 lea     keystat(PC),a0
 move.w  #$FFFE,d0
 moveq   #9,d1
GetKeys:
 move.w  d0,$600018
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 move.b  $60001B,(a0)+
 rol.w   #1,d0
 dbra    d1,GetKeys
 movem.l (a7)+,d0-d1/a0
 rts


;***************************************;
;***************************************;
getpixel:                               ;(d0,d1)=(x,y) sortie:bit  d2
 movem.l d0-d3/a1,-(a7)
 ;add.w   #5,d0            ;4         
 ;add.w   #5,d1                       
 move.l  hptr,a1
 move.w  d1,d2
 lsl.w   #2,d1
 move.w  d1,d2
 lsl.w   #1,d2
 move.w  d2,d3
 lsl.w   #2,d3
 add.w   d3,d2
 add.w   d2,d1
 add.l   d1,a1                          ;a1=a1+44y

 move.w  d0,d2
 lsr.w   #3,d2
 add.l   d2,a1

 move.w  d0,d2                          ;dplacement par rapport au plus proche word
 and.w   #%111,d2                       ;garde bits 1-4 (0-15)
 move.b  #7,d1
 sub.b   d2,d1
 move.b  (a1),d0
 btst.b  d1,d0
 beq     getblanc
getnoir:        
 move.b  #1,d4
 movem.l (a7)+,d0-d3/a1
 rts
getblanc:        
 move.b  #0,d4
 movem.l (a7)+,d0-d3/a1
 rts


;**************************;
PutSprite:                              ;code borrowed from sprite.asm
 movem.l d0-d3/a0-a3,-(a7)
 move.l  hptr,a1   
 subq    #8,d0
 subq    #8,d1
 move.w  d1,d2
 lsl.w   #2,d1
 move.w  d1,d2
 lsl.w   #1,d2
 move.w  d2,d3
 lsl.w   #2,d3
 add.w   d3,d2
 add.w   d2,d1
 add.l   d1,a1                  ;a1=a1+44y

 move.w  d0,d2
 and.w   #$F,d2
 and.w   #$FFF0,d0
 asr.w   #3,d0
 ext.l   d0
 adda.l  d0,a1                  a1=address to start putting sprite at
 
 
 lea     backstore,a2
 move.l  a1,(a2)+
 tst.w   d2
 beq     QuickPut               if x is on a word boundary we're OK
 cmp.w   #8,d2
 blt     RightShift

LeftShift:
 move.w  #1,(a2)+
 sub.w   #16,d2
 neg.w   d2
 move.w  #15,d3
LeftLoop:
 move.l  (a1),d0
 move.l  d0,(a2)+               store background

 move.l  #0,d1

 move.w  32(a0),d1              get mask
 lsl.l   d2,d1                  shift it
 not.l   d1
 and.l   d1,d0                  and with back
 move.l  #0,d1
 move.w  (a0)+,d1               get data
 lsl.l   d2,d1                  shift it
 or.l    d1,d0                  or with back+mask
 move.l  d0,(a1)                put it on the screen
 lea     44(a1),a1              next line
 dbra    d3,LeftLoop            loop
 movem.l (a7)+,d0-d3/a0-a3 
 rts

RightShift:
 move.w  #1,(a2)+
 move.w  #15,d3
RightLoop:
 move.l  (a1),d0
 move.l  d0,(a2)+               store background
 move.l  #0,d1
 move.w  32(a0),d1              get mask
 swap    d1
 lsr.l   d2,d1                  shift it
 not.l   d1
 and.l   d1,d0                  and with back

 move.l  #0,d1
 move.w  (a0)+,d1               get data
 swap    d1
 lsr.l   d2,d1                  shift it
 or.l    d1,d0                  or with back+mask
 move.l  d0,(a1)                put it on the screen
 lea     44(a1),a1              next line
 dbra    d3,RightLoop           loop
 movem.l (a7)+,d0-d3/a0-a3 
 rts

QuickPut:
 move.w  #0,(a2)+
 move.w  #15,d3
QuickLoop:
 move.w  (a1),d0
 move.w  d0,(a2)+               store background
 move.w  32(a0),d1              get mask
 not.w   d1
 and.w   d1,d0                  and with back

 move.w  (a0)+,d1               get data
 or.w    d1,d0                  or with back+mask
 move.w  d0,(a1)                put it on the screen
 lea     44(a1),a1              next line
 dbra    d3,QuickLoop           loop
 movem.l (a7)+,d0-d3/a0-a3 
 rts

;*********************************************************
RemoveSprite:
 
 lea     backstore,a1
 move.l (a1)+,a0
 tst.w  (a1)+
 beq    QuickRemove

 move.w #15,d1
RemoveLoop:
 move.l (a1)+,(a0)
 lea    44(a0),a0
 dbra   d1,RemoveLoop
 rts

QuickRemove:
 move.w #15,d1
QRemoveLoop:
 move.w (a1)+,(a0)
 lea    44(a0),a0
 dbra   d1,QRemoveLoop
 rts


;**************************;
loadlevel:                              ;D0:handle du circuit
 bsr     clrscr
 writestr #0,#100,#4,loading       
 movem.l d0-d7/a0-a1,-(a7)
 move.w  choice,d3
 jsr     hufflib::check_mem             ; Check if there is free memory
 tst.w   d0                             ; If 0, out of mem
 beq     NORMAL_EXIT
 lea     circuit(PC),a0                 ; Make A0 point to huffman compressed data
; move.l  #LCD_MEM,a1                    ; I know it's ugly, but this is usefull!!!         
 move.l  IOptr,a1
 move.w  choice,d3                      ; File 1 (ie, file 2 of 3, cc2.bin)
 jsr     hufflib::extract               ; Extract A0 -> A1

okgo_on_y_va:
; move.l  #LCD_MEM,a1
 move.l  IOptr,a1
 move.l  hptr,a0                        ;handle destination (circuit dcompress, prt  tre affich)
 clr.l   d0
 clr.l   d7
 move.w  (a1)+,d7                       ;lit la taille (en word)
 sub.w   #1,d7

 moveq   #1,d2                          ;couleur de dpart (noir)
 clr.w   d0
 moveq   #15,d3                         ;compteur des pixels

Nouvelle_Couleur:
 move.w  (a1)+,d6                       ;lit nb pixels conscutifs ^m couleur
 sub.w   #1,d6
Pixel_Suivant:                          ;dessine tous les pixels conscutifs d'une mme couleur
 cmp     #0,d3                          ;pixel suivant pas dans mme word ?
 bne     toujours_m_word                ;non=>toujours_m_word
 moveq   #16,d3                         ;oui, word suivant :
 move.w  d0,(a0)+
 clr.w   d0
toujours_m_word:
 sub.w   #1,d3                          ;pixel suivant.
 cmp     #0,d2                          ;pixel  effacer ?
 beq     pixel_blanc
 bset.w  d3,d0
 pixel_blanc:
 dbra    d6,Pixel_Suivant
 eori.b  #1,d2                          ;chgt de couleur 1<=>0    
 dbra    d7,Nouvelle_Couleur

 lea     lapline(PC),a0                 ;lit les contr"les  : 4*((x1,y1)(x2,y2))
 moveq   #11,d2
readlapline:
 move.w  (a1)+,(a0)+
 dbra    d2,readlapline

 move.w  (a1)+,x
 move.w  (a1)+,y
 move.w  (a1)+,angle

; move.l  a1,best2_addr
; move.w  (a1)+,best2                    ;meilleur temps sur ce circuit
 lea     BestTimes(PC),a1
 move.w  choice,d1
 mulu    #2,d1
 add.w   d1,a1
 move.w  (a1)+,best2
EndLoad:
 movem.l (a7)+,d0-d7/a0-a1
 rts  

;***********************contrast***************************
IncContrast:
 moveq   #9,d0
 trap    #9
 jsr     (a0)
 bra retour
DecContrast:
 moveq   #10,d0
 trap    #9
 jsr     (a0)
 bra retour

;******************PASSAGE ENTRE DEUX BORNES*******************;


checkpass:
 movem.l d0-d7/a0,-(a7)
 lea     coord(PC),a0                   ;a0 pointe sur les coordonnes des pts
;DET(AB,AC) = ab*ac*sin(AB,AC)
 move.w  4(a0),d1                       ;b.x
 sub.w   (a0),d1                        ;-a.x
 move.w  10(a0),d7                      ;c.y
 sub.w   2(a0),d7                       ;-a.y
 muls    d7,d1                          ;d1.l=(b.x-a.x)*(c.y-a.y)
 move.w  6(a0),d7                       ;b.y
 sub.w   2(a0),d7                       ;-a.y
 move.w  8(a0),d6                       ;c.x
 sub.w   (a0),d6                        ;-a.x
 muls    d6,d7                          ;d7.l=(b.y-a.y)*(c.x-a.x)
 sub.l   d7,d1                          ;d1=Ka1
;DET(AD,AB) = ab*ac*sin(AD,AB)
 move.w  12(a0),d2                      ;d.x
 sub.w   (a0),d2                        ;-a.x
 move.w  6(a0),d7                       ;b.y
 sub.w   2(a0),d7                       ;-a.y
 muls    d7,d2                          ;d2.l=(d.x-a.x)*(b.y-a.y)
 move.w  14(a0),d7                      ;d.y
 sub.w   2(a0),d7                       ;-a.y
 move.w  4(a0),d6                       ;b.x
 sub.w   (a0),d6                        ;-a.x
 muls    d6,d7                          ;d7.l=(d.y-a.y)*(b.x-a.x)
 sub.l   d7,d2                          ;d2=Ka2
;DET(CA,CD) = ab*ac*sin(CA,CD)
 move.w  (a0),d3                        ;a.x
 sub.w   8(a0),d3                       ;-c.x
 move.w  14(a0),d7                      ;d.y
 sub.w   10(a0),d7                      ;-c.y
 muls    d7,d3                          ;d3.l=(a.x-c.x)*(d.y-c.y)
 move.w  2(a0),d7                       ;a.y
 sub.w   10(a0),d7                      ;-c.y
 move.w  12(a0),d6                      ;d.x
 sub.w   8(a0),d6                       ;-c.x
 muls    d6,d7                          ;d7.l=(a.y-c.y)*(d.x-c.x)
 sub.l   d7,d3                          ;d3=Ka3
;DET(CD,CB) = ab*ac*sin(CD,CB)
 move.w  12(a0),d4                      ;d.x
 sub.w   8(a0),d4                       ;-c.x
 move.w  6(a0),d7                       ;b.y
 sub.w   10(a0),d7                      ;-c.y
 muls    d7,d4                          ;d4.l=(d.x-c.x)*(b.y-c.y)
 move.w  14(a0),d7                      ;d.y
 sub.w   10(a0),d7                      ;-c.y
 move.w  4(a0),d6                       ;b.x
 sub.w   8(a0),d6                       ;-c.x
 muls    d6,d7                          ;d7.l=(d.y-c.y)*(b.x-c.x)
 sub.l   d7,d4                          ;d4=Ka4

 clr.b   borneflag
 cmp.l   #0,d1
 ble     PasPasse
 cmp.l   #0,d2
 ble     PasPasse
 cmp.l   #0,d3
 ble     PasPasse
 cmp.l   #0,d4
 ble     PasPasse
 move.b  #1,borneflag                   ;si les 4 Ka sont >0, les segments se coupent
PasPasse:
 movem.l (a7)+,d0-d7/a0
 rts

;twopla:
 ;tst.w   twopl
 ;beq     Main_
 ;bsr     clrscr
 ;move.w  #0,-(a7)                       ;fonte texte #0
 ;jsr     tios::FontSetSys
 ;lea     2(a7),a7
 ;writestr #84,#71,#4,canctxt
 ;move.w  #2,-(a7)                       ;fonte texte #2
 ;jsr     tios::FontSetSys
 ;lea     2(a7),a7
 ;writestr #90,#60,#4,waittxt

; move.b  #$AA,d0
; bsr     SendByte
;WaitReply:
; bsr     getkeystat
; bsr     ReceiveByte
;NoByte:
; cmp.b   #$AA,d0
; beq     SynchDone
; btst.b  #6,keystat+7                  ;APPS
; bne     WaitReply
; addq    #4,a7
; bra     menu
;SynchDone:
; move.b  #$AA,d0
; bsr     SendByte
; rts

;SendByte:
; movem.l d0-d1/a0-a1,-(a7)
; move.b  d0,linkbuf
; move.w  #1,-(a7)
; pea     linkbuf(PC)
; jsr     tios::transmit
; addq    #6,a7
; movem.l (a7)+,d0-d1/a0-a1     ;
; rts

;ReceiveByte:
; movem.l d1/a0-a1,-(a7)
; clr.b   linkbuf
; move.w  #1,-(a7)
; pea     linkbuf(PC)
; jsr     tios::receive
; addq    #6,a7
; clr.l   d0
; move.b  linkbuf(PC),d0
; movem.l (a7)+,d1/a0-a1
; rts


;**************************************

Fline:                                          ;Thx to Jimmy Mardell
 cmp.w   d0,d2 
 bcc DXpos 
 exg d0,d2 
 exg d1,d3 
DXpos: 
 move.w  d1,d4 
 move.w  d1,d5 
 lsl.w   #5,d4 
 lsl.w   #1,d5 
 sub.w   d5,d4 
 move.w  d0,d5 
 lsr.w   #3,d5 
 add.w   d5,d4 
 move.w  d0,d5 
 not     d5 
 and.b   #$07,d5 
 adda    d4,a0 
 bset.b  d5,(a0) 
 move.b  d5,d6 
 moveq   #1,d5 
 lsl     d6,d5 
 move.w  d2,d6 
 sub.w   d0,d6 
ChY: 
 cmp.w   d1,d3 
 bcc DYpos 
 moveq   #-30,d4 
 move.w  d1,d7 
 sub.w   d3,d7 
 bra PutP1 
DYpos: 
 moveq   #30,d4 
 move.w  d3,d7 
 sub.w   d1,d7 
PutP1:           ; d4 = YAI, d5 = bit, d6 = DX, d7 = DY, A0 = Ptr 
 cmp.w   d0,d2 
 bne DotsNE 
 cmp.w   d1,d3 
 beq LineDone 
DotsNE: 
 cmp.w   d6,d7 
 bcc DY_Greater 
 move.l  d6,d2 
 subq    #1,d2   ; d2 = number of pixels to be plot 
 move.w  d7,d3 
 sub.w   d6,d3   ; d3 = dy-dx 
 asl.w   #1,d3   ; d3 = ai 
 lsl.w   #1,d7   ; d7 = bi 
 sub.w   d7,d6 
 neg     d6      ; d6 = d 
RepX: 
 or.w    d6,d6 
 bmi X_DNeg 
 adda    d4,a0 
 add.w   d3,d6 
 bra IncX 
X_DNeg: 
 add.w   d7,d6 
IncX: 
 ror.b   #1,d5 
 bcc X_SameByte 
 addq    #1,a0 
X_SameByte: 
 or.b    d5,(a0) 
 dbra    d2,RepX 
 bra LineDone 
DY_Greater: 
 move.l  d7,d3 
 subq    #1,d3   ; d3 = number of pixels to be plot 
 move.w  d6,d2 
 sub.w   d7,d2   ; d2 = dx-dy 
 lsl.w   #1,d2   ; d2 = ai 
 lsl.w   #1,d6   ; d6 = bi 
 sub.w   d6,d7 
 neg     d7      ; d7 = d 
RepY: 
 or.w    d7,d7 
 bmi Y_DNeg 
 ror.b   #1,d5 
 bcc Y_SameByte 
 addq    #1,a0 
Y_SameByte: 
 add.w   d2,d7 
 bra IncY 
Y_DNeg: 
 add.w   d6,d7 
IncY: 
 adda    d4,a0 
 or.b    d5,(a0) 
 dbra    d3,RepY 
LineDone: 
 rts 

;*************************************
clrscr:
 move.l  #LCD_MEM,a0
 move.w  #959,d0
clrs:
 clr.l   (a0)+
 dbra    d0,clrs
 rts

;********************************************************
clrr:
 move.l  #LCD_MEM,a0
 add.w   #262,a0
 move.w  #16,d0
clrrr:
 clr.l   (a0)
 add.w   #30,a0
 dbra    d0,clrrr
 rts



;*********NOUVELLE INTERRUPTION #1******;

newint#1:
 cmp     #9999,timer
 bne     ni1s
 move.b  #1,timeflag
 add.w   #1,timer2 
 rte
ni1s:
 add.w   #1,timer
 add.w   #1,timer2
 rte

;*************VARIABLES*****************;

oldint#1 dc.l 0
cos_ptr  dc.l 0
hptr     dc.l 0
IOptr    dc.l 0
Grptr    dc.l 0

x        dc.w 0
y        dc.w 0
x_       dc.w 0            
y_       dc.w 0
xs       dc.w 0
ys       dc.w 0
ligne    dc.w 0           
lastx    dc.w 0
lasty    dc.w 0
hnum     dc.w 0  
xecran   dc.w 0
yecran   dc.w 0
angle    dc.w 0
;oldangle dc.w 0          
braquage dc.w 0
;twopl    dc.w 0
vitesse  dc.w 0
vitess   dc.w 0            
vitt     dc.w 0           
curline  dc.w 0
timer    dc.w 0
timer2   dc.w 0
delayvar dc.w 0 
;test     dc.b 0
lasttime dc.w 0
best1    dc.w 0
best2    dc.w 0
BestTimes:
	 dc.w 9999                 ;Circ03
	 dc.w 9999                 ;Circ02
	 dc.w 9999                 ;circ01
borneflag dc.w 0
choice   dc.w 0
timeflag dc.b 0
lapflag  dc.b 0
;linkbuf  dc.b 0
news     dc.b 0            

;error1   dc.b "YOU NEED ABOUT 9860 FREE BYTES",0,0        ;much more!!!!
;waittxt  dc.b "WAITING",0
;canctxt  dc.b "PRESS APPS TO CANCEL",0

title    dc.b "SUPERCAR I v1.0",0
credit   dc.b "- by Th.FERNIQUE & A.JALABERT 1998 -",0,0   ;  hey!!!    ;)
mail     dc.b "FFernique@eisti.fr    kty@mailcity.com",0
timemsg1 dc.b "LAST TIME :",0
timemsg2 dc.b "CURRENT TIME :",0,0
bestmsg1 dc.b "BEST TIME 1 :",0
bestmsg2 dc.b "BEST TIME 2 :",0
loading  dc.b "Loading track...",0,0
menumsg1 dc.b "[F1]  One player",0
menuselect1:
 dc.b "Circuit1",0,0
 dc.b "Circuit2",0,0
 dc.b "Circuit3",0,0
exittt   dc.b "[ESC]  Exit",0
menuc dc.w 83,41,156,84,0,0
	  dc.l menutxt,0
menutxt dc.b " ",0


lapline  ds.w 12
str      ds.b 8
strend
coord    ds.w 8
keystat  ds.b 10
autoo    ds.l 32

backstore:
	dc.l 0
	dc.w 0
	dcb.l 16,0

	
_comment: dc.b "SUPERCAR I v1.0 by TLP & Kty",0           ; !!!  :)



costab:   INCBIN costab.bin


circuit:  
	incbin  supercar.huf

;*************** End of Fargo program ****************

 
 end
